// pages/lw-baobiaochaxun/lw-baobiaochaxun.js
const app = getApp()
Page({

  /**
   * 页面的初始数据
   */
  data: {
    projectName:'',
    date: '',
    today:'',
    show: false,
    minDate: new Date(2020, 0, 1).getTime(),
    maxDate: new Date().getTime(),
    tableList:[],
    tableListNew:[],
    loadShow:false,
    pageNum:1,
    //静态变量
    type:false,
  },

  onClickShow() {
    this.setData({ loadShow: true });
  },

  onClickHide() {
    this.setData({ loadShow: false });
  },

  onDisplay() {
    this.setData({ show: true });
  }, 
  onClose() {
    this.setData({ show: false });
  },
  formatDate(date) {
    date = new Date(date);
    var dateYaer = date.getFullYear();
    var dateMonth = date.getMonth() + 1;
    var dateDay = date.getDate();
    if(dateMonth < 10 ){
      dateMonth = '0' + dateMonth;
    }
    if(dateDay < 10 ){
      dateDay = '0' + dateDay;
    }
    return  dateYaer+'-'+dateMonth+ '-'+dateDay;
  },

  onConfirm(event) {
    this.onClickShow();
    this.setData({
      show: false,
      date: this.formatDate(event.detail),
      tableListNew:[],
      pageNum:1
    });
    this.selectClockPunch(app.globalData.projectId,this.formatDate(event.detail),1,20);
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.onClickShow();
    var date = new Date();
    var dateYaer = date.getFullYear();
    var dateMonth = date.getMonth() + 1;
    var dateDay = date.getDate();
    if(dateMonth < 10 ){
      dateMonth = '0' + dateMonth;
    }
    if(dateDay < 10 ){
      dateDay = '0' + dateDay;
    }
    this.setData({
      date: dateYaer+'-'+dateMonth+ '-'+dateDay,
    });
    this.setData({
      today:dateYaer+'-'+dateMonth+ '-'+dateDay,
      projectName:app.globalData.projectName,
      tableListNew:[]
    })
    this.selectClockPunch(app.globalData.projectId,dateYaer+'-'+dateMonth+ '-'+dateDay,1,20);
  },


  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {
    //判断数组是否存在值
    if(this.data.type){
      this.setData({pageNum:this.data.pageNum+1});
      this.selectClockPunch(app.globalData.projectId,this.data.date,this.data.pageNum,20);
    }
   
  },

  /**
   * 获取项目打卡数据
   * @param {*} projectId  项目id
   * @param {*} date  日期
   * @param {*} pageNum  页数(1开始)
   * @param {*} size  每页条数
   */
  selectClockPunch:function(projectId,date,pageNum,size){
    var that = this;
    wx.request({
      url: app.globalData.reqUrl+'/weixin/labour/selectClockPunch',
      data:{
        "projectId":projectId,
        "date":date,
        "pageNum":pageNum,
        "size":size
      },
      method:"GET",
      success:function(res) {
        that.onClickHide();
        if(res.data.code == '200'){
          //赋值
          var tableListNew =that.data.tableListNew;
          for(var i = 0;i<res.data.data.length;i++){
            tableListNew.push(res.data.data[i]);
          }
          //判断查询到的数据是否有值
          var type = true;
          if(res.data.data.length < 20 ){ type = false; }

          that.setData({
            tableList:tableListNew,
            type:type
          })
        }else{
          app.toast(res.data.msg);
        }
      }
    })
  },

  /**
   * 返回劳务管控页面
   */
  goBack:function(){
    wx.redirectTo({
      url: '../lw-index/lw-index',
    })
  }
})