// pages/login/login.js
const app = getApp();
Page({

  /**
   * 页面的初始数据
   */
  data: {
    username:'',
    password:'',
    show:false,
    openId:'', 
  },

  //获取填写的账号信息
  name:function(even){
    this.setData({
      username:even.detail.value
    })
  },
  //获取填写的密码信息
  psw:function(even){
    this.setData({
      password:even.detail.value
    })
  },

  onClickShow() {
    this.setData({ show: true });
  },

  onClickHide() {
    this.setData({ show: false });
  },

  onLoad: function (option) {
     this.getOPenId();
  },

  /**
   * 获取用户openid
   */
  getOPenId:function () {
    wx.login({
      success :res=>{
          console.log(res);
          wx.request({
              url: app.globalData.reqUrl+'/weixin/userLogin/getOpenId', 
              data:{
                  "code": res.code,
                  "appId": app.globalData.appId,
              },
              success:(res)=>{
                  console.log(res);
                  this.setData({
                      openId:res.data.openid,
                  })
                   //验证登录用户 
                  this.selectUserInfoByOpenId(res.data.openid);  
              }
          })
      }
    })
},
   
  //验证用户是否是第一次登陆
  selectUserInfoByOpenId:function(openId){
    var that = this;
    wx.setStorageSync('openId', openId)
    wx.request({
      url: app.globalData.reqUrl+'/weixin/userLogin/selectUserInfoByOpenId',
      data:{
        "openId":openId
      },
      method:"GET",
      success:function(res){
        if(res.data.code == '200'){
          app.globalData.userProjectId = res.data.userinfo.projectId
          //把数据存到缓存中
          wx.setStorage({
            key: 'userinfo',
            data: res.data.userinfo
          });
          //跳转页面
          let isRelogin=wx.getStorageSync("isReload");  
          if(!isRelogin){
            //只有一个项目时直接跳转详情页
            if(res.data.projectInfo!=null || res.data.projectInfo!=undefined){
              //赋值到公共参数
              app.globalData.projectId = res.data.projectInfo.projectId;
              app.globalData.projectName = res.data.projectInfo.projectName;
              app.globalData.projectInfoList = JSON.stringify(res.data.projectInfo.projectInfoList);
              app.globalData.value1 = res.data.projectInfo.shengName;
              app.globalData.value2 = res.data.projectInfo.shiName+'/'+res.data.projectInfo.quName;
              app.globalData.value3 = res.data.projectInfo.logCompanyName;
              wx.redirectTo({
                url: '../xiangmugaikuang/xiangmugaikuang',
              })
            }else{
              wx.redirectTo({
                url: '../map/map',
              });
            }
          }          
        }
      }
    })
   },

  
  //登录
  userLogin:function(){
    var that = this;
    var username = this.data.username;
    var password = this.data.password;
    if(username == ""){
      app.toast("账号不能为空");
      return;
    }
    if(password == ""){
      app.toast("密码不能为空");
      return;
    }
    //启动蒙版
    that.onClickShow();
    //发送请求
    wx.request({
      url: app.globalData.reqUrl+'/weixin/userLogin/checkPassWord',
      data:{
        "username":username,
        "password":password,
        "openId":this.data.openId,
      },
      menubar:"GET",
      success(res){
        console.log(res.data);
        wx.setStorageSync('isReload', "")
          //关闭蒙版
          that.onClickHide();
          if(res.data.data=='200'){
            //把数据存到缓存中
            wx.setStorage({
              key: 'userinfo',
              data: res.data.userinfo
            });
            //只有一个项目时直接跳转详情页
            if(res.data.projectInfo!=null || res.data.projectInfo!=undefined){
              //赋值到公共参数
              app.globalData.projectId = res.data.projectInfo.projectId;
              app.globalData.projectName = res.data.projectInfo.projectName;
              app.globalData.projectInfoList = res.data.projectInfo.projectInfoList;
              app.globalData.value1 = res.data.projectInfo.shengName;
              app.globalData.value2 = res.data.projectInfo.shiName+'/'+res.data.projectInfo.quName;
              app.globalData.value3 = res.data.projectInfo.logCompanyName;
              wx.redirectTo({
                url: '../xiangmugaikuang/xiangmugaikuang',
              })
            }else{
              //跳转页面
              wx.redirectTo({
                url: '../map/map',
              })
            }
          }else{
            app.toast(res.data.info);
          }
      }
    })
  },

})